Bug 732215 - Review Request: mined - Powerful Text Editor
Summary: Review Request: mined - Powerful Text Editor
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Martin Gieseking
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2011-08-20 22:24 UTC by Matthieu Saulnier
Modified: 2011-12-10 21:26 UTC (History)
5 users (show)

Fixed In Version: mined-2011.19-3.el6.1
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2011-12-04 02:29:10 UTC
martin.gieseking: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Matthieu Saulnier 2011-08-20 22:24:41 UTC
Hello,
This is my second package, and I need a sponsor.

Spec URL: http://pingou.fedorapeople.org/RPMs/mined.spec
SRPM URL: http://pingou.fedorapeople.org/RPMs/mined-2011.17-1.fc15.src.rpm
Description: 
Mined is the first editor that provided Unicode support in a plain-text
terminal. It now has both extensive Unicode and CJK support offering
many specific features and covering special cases that other editors
are not aware of (like auto-detection features and automatic handling of
terminal variations or Han character information). Basically, it is an
editor tailored to efficient editing of plain text documents and
programs with features and interactive behavior designed for this
purpose.

Comment 1 Matthieu Saulnier 2011-08-23 22:44:56 UTC
I received an informal review of the package on IRC channel #fedora-devel-fr on Freenode.
J

Comment 2 Sébastien Willmann 2011-08-28 12:21:50 UTC
This is an informal review

[!] rpmlint must be run on every package.
    rpmlint mined-2011.17-1.fc15.src.rpm mined-2011.17-1.fc15.x86_64.rpm mined-debuginfo-2011.17-1.fc15.x86_64.rpm 
    mined.src: I: enchant-dictionary-not-found en_US
    mined.x86_64: W: dangling-relative-symlink /usr/share/doc/mined-2011.17/LICENSE.GNU usrshare/package_doc/LICENSE.GNU
    mined.x86_64: W: dangling-relative-symlink /usr/share/doc/mined-2011.17/CHANGES usrshare/package_doc/CHANGES
    mined.x86_64: W: dangling-relative-symlink /usr/share/doc/mined-2011.17/VERSION usrshare/package_doc/VERSION
    mined.x86_64: W: manual-page-warning /usr/share/man/man1/uterm.1.gz 96: warning: macro `..' not defined
    mined.x86_64: W: manual-page-warning /usr/share/man/man1/mined.1.gz 351: warning: macro `VL' not defined
    mined.x86_64: W: file-not-utf8 /usr/share/man/man1/mined.1.gz
    mined.x86_64: W: dangling-relative-symlink /usr/share/doc/mined-2011.17/README usrshare/package_doc/README
    mined-debuginfo.x86_64: E: debuginfo-without-sources
    3 packages and 0 specfiles checked; 1 errors, 7 warnings.


[X] The package must be named according to the Package Naming Guidelines.

[X] The spec file name must match the base package %{name}, in the format
      %{name}.spec unless your package has an exemption.

[!] The package must meet the Packaging Guidelines.
    Fix rpmlint, license and directory ownership issues.

[!] The package must be licensed with a Fedora approved license and meet the
      Licensing Guidelines.
      The license is GPLv2+, but there is the following sentence in the README file:
      "Also redistributions should not take license/royalty fees for the use 
      of mined or any derived version (it is not very clear to the software 
      community what exactly the GNU license means in this respect)."
      I think this is not acceptable for Fedora (and for the GPL).

[X] The License field in the package spec file must match the actual license.

[X] If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s) for
     the package must be included in %doc.

[X] The spec file must be written in American English.

[X] The spec file for the package MUST be legible.

[X] The sources used to build the package must match the upstream source, as
      provided in the spec URL.
      Upstream: b38eb3c0bf77b76c24ae360f997fca1a
      Package:  b38eb3c0bf77b76c24ae360f997fca1a

[X] The package MUST successfully compile and build into binary rpms on at
     least one primary architecture.
     Build successful on Fedora 15 x86_64

[NA] If the package does not successfully compile, build or work on an
      architecture, then those architectures should be listed in the spec in
      ExcludeArch.

[X] All build dependencies must be listed in BuildRequires, except for any
     that are listed in the exceptions section of the Packaging Guidelines ;
     inclusion of those as BuildRequires is optional.

[NA] The spec file MUST handle locales properly. This is done by using the
      %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.

[NA] Every binary RPM package (or subpackage) which stores shared library
      files(not just symlinks) in any of the dynamic linker's default paths,
      must call ldconfig in %post and %postun.

[X] Packages must NOT bundle copies of system libraries.

[NA] If the package is designed to be relocatable, the packager must state
      this fact in the request for review, along with the rationalization for
      relocation of that specific package. Without this, use of Prefix: /usr is
      considered a blocker.

[!] A package must own all directories that it creates. If it does not create
     a directory that it uses, then it should require a package which does
     create that directory.
     % LANG=C rpm -qf /usr/share/mined
     file /usr/share/mined is not owned by any package


[X] A Fedora package must not list a file more than once in the spec file's
      %files listings. 

[X] Permissions on files must be set properly. Executables should be set with
     executable permissions, for example. Every %files section must include a
     %defattr(...) line.

[X] Each package must consistently use macros.

[X] The package must contain code, or permissable content.

[NA] Large documentation files must go in a -doc subpackage.

[X] If a package includes something as %doc, it must not affect the runtime
     of the application. To summarize: If it is in %doc, the program must run
     properly if it is not present.

[NA] Header files must be in a -devel package.

[NA] Static libraries must be in a -static package.

[NA] If a package contains library files with a suffix (e.g. libfoo.so.1.1),
      then library files that end in .so (without suffix) must go in a -devel
      package.

[NA] In the vast majority of cases, devel packages must require the base
      package using a fully versioned dependency: Requires: %{name} =
      %{version}-%{release}.

[X] Packages must NOT contain any .la libtool archives, these must be removed
      in the spec if they are built.

[X] Packages containing GUI applications must include a %{name}.desktop file,
      and that file must be properly installed with desktop-file-install in the
      %install section.

[X] Packages must not own files or directories already owned by other
      packages.

[X] All filenames in rpm packages must be valid UTF-8.

There are some issues with this package:
- I don't think that the license is acceptable for fedora. Ask upsteam to change it.
- rpmlint errors and warnings should be fixed, unless you have good reasons not to do it.
- The package must own %{_datadir}/mined (everything inside this directory will be owned automatically).
I think you could also put ${_bindir}/* in the file section instead of listing manually every file in this directory.

Comment 3 Michael Schwendt 2011-09-03 18:51:53 UTC
* Removing FE-NEEDSPONSOR as I see you've been sponsored already.


* Licensing issue: This is ambiguous and therefore not acceptable. Sublicensing (or restricting the GPL further) also violates the GPL itself. It would be better if upstream simply acknowledge the GPL licensing without trying to add extra licensing terms. You might want to point upstream at: 

http://www.gnu.org/philosophy/free-sw.html
http://www.gnu.org/licenses/gpl-faq.html


> rm -rf %{buildroot}%{_datadir}/mined/help/mined.hlp          \
>       %{buildroot}%{_datadir}/mined/setup_install/win       \
>       %{buildroot}%{_datadir}/mined/setup_install/bin       \
>       %{buildroot}%{_datadir}/mined/setup_install/mined.ico \
>       %{buildroot}%{_datadir}/mined/bin                     \
>       %{buildroot}%{_datadir}/mined/package_doc

Great opportunity to add a brief comment to the spec file explaining why this is done. What files are these? Why are they not needed? Often, deleting files is dubious activity that bears a risk of breaking the package, e.g. due to missing files at run-time.


> %{_datadir}/mined/conf_user/*
> %{_datadir}/mined/doc_user/*

Three directories are not included here:
https://fedoraproject.org/wiki/Packaging:UnownedDirectories


> gcc -DTERMIO -Dunix -DsysV -Dunix -ansi -Waggregate-return -Winline
> -Wimplicit-int -Wunused -Wswitch -Wchar-subscripts -Wparentheses
> -Wmissing-braces  -Wno-pointer-sign -O2  -Wmissing-prototypes
> -Wreturn-type -DRUNDIR=\"/usr/share/mined\"
> -DLRUNDIR=\"/usr/local/share/mined\" -c mined1.c

Fedora's optflags are not used.
The /usr/local/… path is suspicous.


* Notice .desktop file warnings in build output.


* Run rpmlint also on all built rpms, not just the src.rpm. There are some real errors reported there. If in doubt, use rpmlint -i.

Comment 4 Matthieu Saulnier 2011-09-04 06:04:18 UTC
(In reply to comment #3)
> * Removing FE-NEEDSPONSOR as I see you've been sponsored already.
Sorry, I don't have a sponsor.

However, I'm fixing the license with uptream.

Comment 5 Michael Schwendt 2011-09-05 18:37:21 UTC
> http://pingou.fedorapeople.org/RPMs/mined.spec

Ah, indeed you are not 'pingou' in FAS, but only using his webspace somehow. That has confused me, and I've had to look at the account details.

Comment 6 Pierre-YvesChibon 2011-10-11 16:05:31 UTC
@ Matthieu, do you have a new version of this package taking the given remarks into account ?

Comment 7 Matthieu Saulnier 2011-10-11 16:34:24 UTC
Not yet, the developer need some more time.

Comment 8 Martin Gieseking 2011-11-05 12:30:44 UTC
I've sponsored Matthieu, thus removing FE-NEEDSPONSOR.

Comment 9 Matthieu Saulnier 2011-11-17 00:51:12 UTC
Hello,
This is a new version of the package.

Spec URL: http://fantom.fedorapeople.org/mined.spec
SRPM URL: http://fantom.fedorapeople.org/mined-2011.19-1.fc16.src.rpm

Comment 10 Martin Gieseking 2011-11-19 23:16:09 UTC
Hi Matthieu,

there are still a couple of things that need to be addressed:

- Add file ./usrshare/package_doc/README to the %docs because it contains the
  information that mined is licensed under GPLv3.
  Additionally, the developer(s) should add the license header to all source 
  files as requested by the GPL. This isn't a blocker, though.

- change the permissions of the spec file to 644 (see rpmlint output)

- the manpage and file CHANGES must be converted to UTF8 (without changing 
  the timestamps), e.g. like so (in %prep):
  for f in CHANGES man/mined.1; do
    iconv -f iso-8859-1 -t utf8 $f >$f.tmp && \
    touch -r $f $f.tmp && \
    mv $f.tmp $f
  done

- Fedora's %optflags are not applied. To fix this, add OPT='%{optflags}' to 
  the make statement.

- In the .desktop file, remove the .xpm suffix from the icon filename (see 
  desktop-file-validate output below). The proper extension is detected 
  automatically.

- xmined, umined, and uterm need xterm to work properly. Thus, you should add 
  Require: xterm. However, I suggest to split the binaries that rely on X to 
  a subpackage, e.g. "xmined", so that mined can be used in plain text-mode 
  environments as well without the need to install the whole X stuff.

- The help function (F1) doesn't work because file mined.hlp is missing. It's 
  not a Windows help file as indicated by your comment in the spec. 
  Add it to the package, e.g. to folder /usr/share/mined/help/.

- The html documentation should go to /usr/share/doc/%{name}-%{version}. 
  Currently, it's located in /usr/share/mined/doc_user/


$ rpmlint  *.rpm
mined.src: W: strange-permission mined.spec 0666L
mined.x86_64: W: file-not-utf8 /usr/share/doc/mined-2011.19/CHANGES
mined.x86_64: W: file-not-utf8 /usr/share/man/man1/mined.1.gz
3 packages and 0 specfiles checked; 0 errors, 3 warnings.


$ desktop-file-validate mined.desktop 
mined.desktop: error: (will be fatal in the future): value "mined.xpm" for key "Icon" in group "Desktop Entry" is an icon name with an extension, but there should be no extension as described in the Icon Theme Specification if the value is not an absolute path



---------------------------------
key:

[+] OK
[.] OK, not applicable
[X] needs work
---------------------------------

[+] MUST: The package must be named according to the Package Naming Guidelines.
[+] MUST: The spec file name must match the base package %{name}.
[+] MUST: The package must meet the Packaging Guidelines.
[+] MUST: The package must be licensed with a Fedora approved license.
[+] MUST: The License field in the package spec file must match the actual license.
[+] MUST: The file containing the text of the license(s) for the package must be included in %doc.
[+] MUST: The spec file must be written in American English.
[+] MUST: The spec file for the package MUST be legible.
[+] MUST: The sources used to build the package must match the upstream source.
    $ md5sum mined-2011.19.tar.gz*
    89e7a316e0918b8d1c001871f6e1aefd  mined-2011.19.tar.gz
    89e7a316e0918b8d1c001871f6e1aefd  mined-2011.19.tar.gz.upstream

[+] MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
[.] MUST: If the package does not successfully compile, build or work on an architecture, ...
[+] MUST: All build dependencies must be listed in BuildRequires.
[X] MUST: When compiling C, C++, or Fortran files, %{optflags} must be applied.
    - add OPT='%{optflags} to "make"

[.] MUST: The spec file MUST handle locales properly.
[.] MUST: Packages storing shared library files (not just symlinks) must call ldconfig in %post and %postun.
[+] MUST: Packages must NOT bundle copies of system libraries.
[.] MUST: If the package is designed to be relocatable, ...
[+] MUST: A package must own all directories that it creates. 
[+] MUST: A Fedora package must not list a file more than once in %files.
[X] MUST: Permissions on files must be set properly.
    - fix the permissions of the .spec file

[+] MUST: Each package must consistently use macros.
[+] MUST: The package must contain code, or permissable content.
[.] MUST: Large documentation files must go in a -doc subpackage.
[+] MUST: Files in %doc must not affect the runtime of the application.
[.] MUST: Header files must be in a -devel package.
[.] MUST: Static libraries must be in a -static package.
[.] MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.
[.] MUST: devel packages must require the base package using a fully versioned dependency.
[+] MUST: Packages must NOT contain any .la libtool archives.
[+] MUST: Packages containing GUI applications must include a %{name}.desktop file 
[+] MUST: .desktop filex must be properly installed with desktop-file-install in the %install section.
[+] MUST: Packages must not own files or directories already owned by other packages.
[X] MUST: All filenames in rpm packages must be valid UTF-8.
    - CHANGES and mined.1 are iso-8859-1 
    - convert them to UTF8 (with iconv)

EPEL <= 5 only:
[X] MUST: The spec file must contain a valid BuildRoot field.
[X] MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot}.
[X] MUST: Each package must have a %clean section, which contains rm -rf %{buildroot}.
[.] MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig'

[.] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
[+] SHOULD: Timestamps of files should be preserved.
[+] SHOULD: The reviewer should test that the package builds in mock.
[+] SHOULD: The package should compile and build into binary rpms on all supported architectures.
[X] SHOULD: The reviewer should test that the package functions as described.
    - help doesn't work

[.] SHOULD: If scriptlets are used, those scriptlets must be sane.
[.] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
[.] SHOULD: pkgconfig(.pc) files should be placed in a -devel pkg.
[.] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.
[+] SHOULD: Your package should contain man pages for binaries/scripts.

Comment 11 Matthieu Saulnier 2011-11-21 14:11:11 UTC
Hi Martin, thanks for the review.
This is the latest release :
Spec URL: http://fantom.fedorapeople.org/mined.spec
SRPM URL: http://fantom.fedorapeople.org/mined-2011.19-2.fc16.src.rpm

Comment 12 Martin Gieseking 2011-11-22 18:53:20 UTC
The package looks good now. You don't need to make the dependency on xterm arch specific, so you can remove %{?_isa} here. 

----------------
Package APPROVED
----------------

Comment 13 Matthieu Saulnier 2011-11-22 21:53:59 UTC
(In reply to comment #12)
> You don't need to make the dependency on xterm arch
> specific, so you can remove %{?_isa} here. 
Done

Spec URL: http://fantom.fedorapeople.org/mined.spec
SRPM URL: http://fantom.fedorapeople.org/mined-2011.19-3.fc16.src.rpm


New Package SCM Request
=======================
Package Name: mined
Short Description: Powerful Text Editor
Owners: fantom
Branches: f15 f16 el6
InitialCC:

Comment 14 Gwyn Ciesla 2011-11-23 01:43:00 UTC
Git done (by process-git-requests).

Comment 15 Fedora Update System 2011-11-23 11:53:05 UTC
mined-2011.19-3.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/mined-2011.19-3.fc16

Comment 16 Fedora Update System 2011-11-23 12:02:01 UTC
mined-2011.19-3.fc15 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/mined-2011.19-3.fc15

Comment 17 Fedora Update System 2011-11-23 14:05:57 UTC
mined-2011.19-3.fc16.1 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/mined-2011.19-3.fc16.1

Comment 18 Fedora Update System 2011-11-23 14:16:49 UTC
mined-2011.19-3.fc15.1 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/mined-2011.19-3.fc15.1

Comment 19 Fedora Update System 2011-11-23 14:18:15 UTC
mined-2011.19-3.el6.1 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/mined-2011.19-3.el6.1

Comment 20 Fedora Update System 2011-11-23 23:29:53 UTC
mined-2011.19-3.fc15.1 has been pushed to the Fedora 15 testing repository.

Comment 21 Fedora Update System 2011-12-04 02:29:10 UTC
mined-2011.19-3.fc16.1 has been pushed to the Fedora 16 stable repository.

Comment 22 Fedora Update System 2011-12-04 02:43:16 UTC
mined-2011.19-3.fc15.1 has been pushed to the Fedora 15 stable repository.

Comment 23 Fedora Update System 2011-12-10 21:26:21 UTC
mined-2011.19-3.el6.1 has been pushed to the Fedora EPEL 6 stable repository.


Note You need to log in before you can comment on or make changes to this bug.